variables:
  CSERPH_VERSION: latest
  PORTER_RUNTIME_VERSION: latest
  DIND_VERSION: dind

stages:
  - validate
  - prepublish
  - publish

validate-packaging:
  image: registry.gitlab.com/centros.one/packaging/cserph:$CSERPH_VERSION
  stage: validate
  script:
    - cserph validate

render-porter-yaml:
  image: registry.gitlab.com/centros.one/packaging/cserph:$CSERPH_VERSION
  stage: prepublish
  script:
    - cserph render
      -u /version="$CI_COMMIT_TAG"
      -u /registry="$DOCKER_REPO_PROJECT"
  artifacts:
    paths:
      - cnab/porter.yaml
  rules:
    # only if the tag is a valid semver compliant version number
    - if: '$CI_COMMIT_TAG =~ /^(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)(?:-((?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*)(?:\.(?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*))*))?(?:\+([0-9a-zA-Z-]+(?:\.[0-9a-zA-Z-]+)*))?$/'

porter-publish:
  image: registry.gitlab.com/centros.one/packaging/porter-docker-runtime:$PORTER_RUNTIME_VERSION
  stage: publish
  services:
    - docker:$DIND_VERSION
  before_script:
    - registry=$(echo $DOCKER_REPO_PROJECT | awk -F/ '{print $1}')
    - docker login -u "$DOCKER_REPO_USER" -p "$DOCKER_REPO_PASSWORD" $registry
  script:
    - cd cnab
    - porter publish
  rules:
    # only if the tag is a valid semver compliant version number
    - if: '$CI_COMMIT_TAG =~ /^(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)(?:-((?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*)(?:\.(?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*))*))?(?:\+([0-9a-zA-Z-]+(?:\.[0-9a-zA-Z-]+)*))?$/'

